﻿' <auto-generated />

Imports System.Activities
Imports System.Globalization
Imports Microsoft.Xrm.Sdk
Imports Microsoft.Xrm.Sdk.Workflow

Namespace NamespaceName
    ''' <summary>
    ''' Base class used for workflows
    ''' </summary>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("XrmToolkit", "XrmToolkitVersion")>
    Partial Public MustInherit Class BaseWorkflowClassName
        Inherits CodeActivity
        Protected Class LocalWorkflowContext
            Implements IDisposable
            Public Property CodeActivityContext As CodeActivityContext

            Public Property WorkflowContext As IWorkflowContext

            Public Property ServiceFactory As IOrganizationServiceFactory

            Public Property CrmContext As Microsoft.Xrm.Sdk.Client.OrganizationServiceContext

            Public Property OrganizationService As IOrganizationService

            Public Property TracingService As ITracingService

            Friend Sub New(codeActivityContext As CodeActivityContext)
                If codeActivityContext Is Nothing Then
                    Throw New ArgumentNullException("codeActivityContext")
                End If

                ' Set the code activity context
                Me.CodeActivityContext = codeActivityContext

                ' Obtain the workflow context from the service provider.
                Me.WorkflowContext = codeActivityContext.GetExtension(Of IWorkflowContext)()

                ' Obtain the tracing service from the service provider.
                Me.TracingService = codeActivityContext.GetExtension(Of ITracingService)()

                ' Obtain the Organization Service factory service from the service provider
                Me.ServiceFactory = codeActivityContext.GetExtension(Of IOrganizationServiceFactory)()

                ' Use the factory to generate the Organization Service.
                Me.OrganizationService = Me.ServiceFactory.CreateOrganizationService(Me.WorkflowContext.UserId)

                ' Generate the CrmContext to use with LINQ etc
                Me.CrmContext = New Microsoft.Xrm.Sdk.Client.OrganizationServiceContext(Me.OrganizationService)
            End Sub
            Friend Sub Trace(message As String)
                If String.IsNullOrWhiteSpace(message) OrElse Me.TracingService Is Nothing Then
                    Return
                End If

                If Me.WorkflowContext Is Nothing Then
                    Me.TracingService.Trace(message)
                Else
                    Me.TracingService.Trace("{0}, Correlation Id: {1}, Initiating User: {2}", message, Me.WorkflowContext.CorrelationId, Me.WorkflowContext.InitiatingUserId)
                End If
            End Sub
            Public Sub Dispose() Implements IDisposable.Dispose
                If Me.CrmContext IsNot Nothing Then
                    Me.CrmContext.Dispose()
                End If
            End Sub
        End Class
        Protected MustOverride Sub ExecuteInternal(context As LocalWorkflowContext)
        Protected Overrides Sub Execute(context As CodeActivityContext)
            Using localContext = New LocalWorkflowContext(context)
                localContext.Trace("Calling ExecuteInternal")
                Try
                    Me.ExecuteInternal(localContext)
                Catch ex As Exception
                    localContext.Trace(String.Format(CultureInfo.InvariantCulture, "Exception: {0}", ex.ToString()))
                    Throw
                Finally
                    localContext.Trace("ExecuteInternal finished")
                End Try
            End Using
        End Sub
    End Class
End Namespace
