﻿using System;
using System.Collections.ObjectModel;
using System.Globalization;
using System.Linq;
using System.ServiceModel;
using Microsoft.Xrm.Sdk;

namespace NamespaceName
{
    public partial class PluginClassName : BasePluginClassName
    {
        public PluginClassName(string unsecureConfig, string secureConfig) : base(unsecureConfig, secureConfig)
        {
            // Register for any specific events by instantiating a new instance of the 'PluginEvent' class and registering it
            base.RegisteredEvents.Add(new PluginEvent()
            {
                Stage = Stage.PostOperation,
                MessageName = MessageNames.MessageNamesPlaceHolder,
                TableName = TableNames.TableNamesPlaceHolder,
                PluginAction = ExecutePluginLogic
            });
        }

        public void ExecutePluginLogic(IServiceProvider serviceProvider)
        {
            // Use a 'using' statement to dispose of the service context properly
            // To use a specific early bound entity replace the 'Entity' below with the appropriate class type
            using (var localContext = new LocalPluginContext<Entity>(serviceProvider))
            {
                // Todo: Place your logic here for the plugin
                
            }
        }
    }
}
