﻿' <auto-generated />

Imports System.Linq
Imports System.Collections.Generic
Imports Microsoft.Crm.Sdk.Messages
Imports Microsoft.Xrm.Sdk
Imports Microsoft.Xrm.Sdk.Query
Imports Microsoft.Xrm.Sdk.Messages
Imports Microsoft.Xrm.Sdk.Metadata
Imports Microsoft.Xrm.Sdk.Client
Imports System.ComponentModel
Imports System.Runtime.Serialization

Namespace ProxyClassNameSpace
    ''' <summary>
    ''' Proxy class that represents the 'LogicalNameString' D365 table
    ''' </summary>
    <EntityLogicalNameAttribute("LogicalNameString")>
    <System.CodeDom.Compiler.GeneratedCodeAttribute("XrmToolkit", "XrmToolkitVersion")>
    <DataContract(Name:="Entity", Namespace:="http://schemas.microsoft.com/xrm/2011/Contracts")>
    Partial Public Class ProxyClassTemplateName
        Inherits _CustomBaseClass_
        Public Shadows Const LogicalName As String = "LogicalNameString"
        Public Const ObjectTypeCode As Integer = 123456
        Public Const PrimaryIdAttribute As String = "PrimaryIdAttributeString"
        Public Const PrimaryNameAttribute As String = "PrimaryNameAttributeString"
        Public Const PrimaryImageAttribute As String = "PrimaryImageAttributeString"
        Shared Sub New()
            _BaseProxyClass_.RegisterProxyType(GetType(ProxyClassTemplateName), "LogicalNameString")
            _textOptionsCollection = New Dictionary(Of String, eTextOptions)()
            _numberOptionsCollection = New Dictionary(Of String, eNumberOptions)()
            _errorStrings = New Dictionary(Of String, String)()
            TextError = "The value for attribute '{0}' cannot be longer than {3} characters. The length of the value is {2} characters."
            NumberError = "The value for attribute '{0}' must be between {2} and {3}. The value is {1}"
        End Sub
        Public Sub New()
            MyBase.New(New Entity("LogicalNameString"))
        End Sub
        Public Sub New(original As Entity)
            MyBase.New(original)
        End Sub
        Public Overloads Shared Function GetLogicalName() As String
            Return _BaseProxyClass_.GetLogicalName(Of ProxyClassTemplateName)()
        End Function

        ''' <summary>
        ''' Action to perform when the string value is greater than the allowed length.
        ''' <para>This is the default for any string attribute in this Entity</para>
        ''' </summary>
        Public Shared Property TextOptions As eTextOptions
        Private Shared _textOptionsCollection As Dictionary(Of String, eTextOptions)
        ''' <summary>
        ''' Use this to set an action and error string when a value is greater than the allowed length
        ''' </summary>
        ''' <param name="logicalName">Name of Attribute</param>
        ''' <param name="options">Action to perform when the value is greater than the allowed length</param>
        ''' <param name="errorString">Optional: Error to throw if the eTextOptions == ThrowError
        ''' <para>If nothing is specified then the 'TextError' string is used.</para>
        ''' <para>You may use the following parameters:</para>
        ''' <para>{0} = Attribute Logical Name</para>
        ''' <para>{1} = Value</para>
        ''' <para>{2} = Length</para>
        ''' <para>{3} = Max Length</para>
        ''' </param>
        Public Shared Sub SetTextOptions(logicalName As String, options As eTextOptions, Optional errorString As String = Nothing)
            If _textOptionsCollection.ContainsKey(logicalName) Then
                _textOptionsCollection(logicalName) = options
            Else
                _textOptionsCollection.Add(logicalName, options)
            End If
            If Not String.IsNullOrEmpty(errorString) Then
                If _errorStrings.ContainsKey(logicalName) Then
                    _errorStrings(logicalName) = errorString
                Else
                    _errorStrings.Add(logicalName, errorString)
                End If
            ElseIf _errorStrings.ContainsKey(logicalName) Then
                _errorStrings.Remove(logicalName)
            End If
        End Sub
        Protected Overrides Function GetTextOptions(logicalName As String) As eTextOptions
            If _textOptionsCollection.ContainsKey(logicalName) Then
                Return _textOptionsCollection(logicalName)
            End If
            Return TextOptions
        End Function
        ''' <summary>
        ''' Action to perform when the number value is greater or less than the allowed value.
        ''' <para>This is the default for any int, decimal, double, or money attribute in this Entity</para>
        ''' </summary>
        Public Shared Property NumberOptions() As eNumberOptions
        Private Shared _numberOptionsCollection As Dictionary(Of String, eNumberOptions)
        ''' <summary>
        ''' Use this to set an action and error string when a value is greater or less than the allowed value
        ''' </summary>
        ''' <param name="logicalName">Name of Attribute</param>
        ''' <param name="options">Action to perform when the value is greater or less than the allowed value</param>
        ''' <param name="errorString">Optional: Error to throw if the eNumberOptions == ThrowError
        ''' <para>If nothing is specified then the 'NumberError' string is used.</para>
        ''' <para>You may use the following parameters:</para>
        ''' <para>{0} = Attribute Logical Name</para>
        ''' <para>{1} = Value</para>
        ''' <para>{2} = Min Value</para>
        ''' <para>{3} = Max Value</para>
        ''' </param>
        Public Shared Sub SetNumberOptions(logicalName As String, options As eNumberOptions, Optional errorString As String = Nothing)
            If _numberOptionsCollection.ContainsKey(logicalName) Then
                _numberOptionsCollection(logicalName) = options
            Else
                _numberOptionsCollection.Add(logicalName, options)
            End If
            If Not String.IsNullOrEmpty(errorString) Then
                If _errorStrings.ContainsKey(logicalName) Then
                    _errorStrings(logicalName) = errorString
                Else
                    _errorStrings.Add(logicalName, errorString)
                End If
            ElseIf _errorStrings.ContainsKey(logicalName) Then
                _errorStrings.Remove(logicalName)
            End If
        End Sub
        Protected Overrides Function GetNumberOptions(logicalName As String) As eNumberOptions
            If _numberOptionsCollection.ContainsKey(logicalName) Then
                Return _numberOptionsCollection(logicalName)
            End If
            Return NumberOptions
        End Function
        Private Shared _errorStrings As Dictionary(Of String, String)
        Protected Overrides Function GetErrorString(attributeName As String, defaultErrorType As _BaseProxyClass_.eErrorType) As String
            If _errorStrings.ContainsKey(attributeName) Then
                Return _errorStrings(attributeName)
            End If
            Return If(defaultErrorType = _BaseProxyClass_.eErrorType.Text, TextError, NumberError)
        End Function
        ''' <summary>
        ''' <para>Default error string is: The value for attribute '{0}' cannot be longer than {3} characters. The length of the value is {2} characters.</para>
        ''' <para>You may use the following parameters</para>
        ''' <para>{0} = Attribute Name</para>
        ''' <para>{1} = Value</para>
        ''' <para>{2} = Length</para>
        ''' <para>{3} = Max Length</para>
        ''' </summary>
        Public Shared Property TextError() As String
        ''' <summary>
        ''' <para>Default error string is: The value for attribute '{0}' must be between {2} and {3}. The value is {1}.</para>
        ''' <para>You may use the following parameters</para>
        ''' <para>{0} = Attribute Name</para>
        ''' <para>{1} = Value</para>
        ''' <para>{2} = Min Value</para>
        ''' <para>{3} = Max Value</para>
        ''' </summary>
        Public Shared Property NumberError As String
        Public Properties As String
        Public OneToManyMethods As String
        Public ManyToManyMethods As String
        Public EntitySpecificMethods As String
        Public Enums As String
        Public PropertyNamesClass As String
    End Class
End Namespace